package org.zeroturnaround.javarebel.integration.generic;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtConstructor;
import org.zeroturnaround.javarebel.RebelServletContext;

public class ServletContextImplClassBytecodeProcessor extends
BaseServletContextImplClassBytecodeProcessor {

	public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
		CtConstructor[] constructors = ctClass.getConstructors();
		for (int i = 0; i < constructors.length; i++) {
			CtConstructor constructor = constructors[i];
			constructor.insertAfter(
					"org.zeroturnaround.javarebel.ServletIntegrationFactory.getInstance()" +
					"  .registerServletContext((" + RebelServletContext.class.getName() + ") $0);");
		}
		
		super.process(cp, cl, ctClass);
	}
}
